#ifndef __HASHMAP_NODE_H
#define __HASHMAP_NODE_H

struct node {
    struct node *next;
    struct node *prev;
    const char *key;
    const char *value;
};

struct node *new_node(const char *key, const char *value);
struct node *insert_node(struct node *entry, const char *key, const char *value);

#endif
